using Furion;
using Furion.DependencyInjection;
using Furion.DistributedIDGenerator;
using Furion.RemoteRequest.Extensions;
using Furion.TaskScheduler;
using Nirvana.Common;
using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Waste.Domain;

namespace Waste.Application
{
    /// <summary>
    /// 投放记录管理
    /// </summary>
    public class ResultService : BaseInfoService, IResultService, ITransient
    {
        private readonly ISqlSugarRepository<W_Result> repository;
        private readonly SqlSugarClient dbClient;
        private readonly ILoggerService _loggerService;
        private readonly ISuZhouService _suZhouService;
        private readonly IBusinessApiService _businessApiService;

        public ResultService(ISqlSugarRepository<W_Result> sqlSugarRepository, ILoggerService loggerService, ISuZhouService suZhouService, IBusinessApiService businessApiService)
        {
            repository = sqlSugarRepository;
            dbClient = repository.Context;
            _loggerService = loggerService;
            _suZhouService = suZhouService;
            _businessApiService = businessApiService;
        }
        /// <summary>
        /// 获取投放记录
        /// </summary>
        /// <param name="param"></param>
        /// <returns></returns>
        public async Task<PageParms<ResultList>> GetListAsync(QueryParams param)
        {
            RefAsync<int> totalnum = 0;
            var temquery = dbClient.Queryable<W_Result>();
            if (param.queryParam != null && param.queryParam.Count > 0)
            {
                List<IConditionalModel> conModels = new List<IConditionalModel>();
                param.queryParam.ForEach(x =>
                {
                    var val = x.Value.ToStrEmpty();
                    if (!string.IsNullOrEmpty(val))
                    {
                        if (x.Name.ToStr().ToLower() == "facecode")
                        {
                            temquery = temquery.Where(t => SqlFunc.Subqueryable<W_Device>().Where(e => e.Ecode == val && t.DeviceId == e.Id).Any());
                        }
                        else if (x.Name.ToStr().ToLower() == "name")
                        {
                            temquery = temquery.Where(t => SqlFunc.Subqueryable<W_Device>().Where(e => e.Name == val && t.DeviceId == e.Id).Any());
                        }
                        else
                        {
                            conModels.Add(new ConditionalModel()
                            {
                                FieldName = x.Name,
                                ConditionalType = (ConditionalType)x.Type,
                                FieldValue = val
                            });
                        }
                    }
                });
                if (conModels.Count > 0)
                {
                    temquery = temquery.Where(conModels);
                }
            }
            //针对非平台类型,则可以查看下面所有的子账户设备
            if (currentUser.AccountType != (int)AccountType.platform)
            {
                var sql = $"code like '{currentUser.BusinessCode}'+'%' and id = x.businessid";
                temquery = temquery.Where(x => SqlFunc.Subqueryable<W_Business>().Where(sql).Any());
            }
            string sorts = string.Format("{0} {1}", param.sort, param.order);
            var query = await temquery.OrderBy(sorts)
                .Select(x => new ResultList
                {
                    Id = x.Id,
                    BusinessId = x.BusinessId,
                    DeviceId = x.DeviceId,
                    WasteType = x.WasteType,
                    Tare = x.Tare,
                    GrossWeight = x.GrossWeight,
                    NetWeight = x.NetWeight,
                    Registration = x.Registration,
                    CreateTime = x.CreateTime,
                    PostStatus= -1
                })
                .Mapper((it, cache) =>
                {
                    var allbus = cache.Get(list =>
                    {
                        var ids = list.Where(e => e.BusinessId != Guid.Empty).Select(e => e.BusinessId).ToList();
                        return dbClient.Queryable<W_Business>().Where(e => ids.Contains(e.Id)).ToList();
                    });
                    it.BusinessName = allbus.FirstOrDefault(e => e.Id == it.BusinessId)?.Name;
                    var alldev = cache.Get(list =>
                    {
                        var ids = list.Where(e => e.DeviceId != Guid.Empty).Select(e => e.DeviceId).ToList();
                        return dbClient.Queryable<W_Device>().Where(e => ids.Contains(e.Id)).ToList();
                    });
                    var dev = alldev.FirstOrDefault(e => e.Id == it.DeviceId);
                    if (dev != null)
                    {
                        it.DeviceName = dev.Name;
                        it.DeviceFacEcode = dev.FacEcode;
                        it.DeviceEcode = dev.Ecode;
                        it.DeviceAddress = dev.Address;
                    }
                    var allres  = cache.Get(list =>
                    {
                        var ids = list.Select(e => e.Id).ToList();
                        return dbClient.Queryable<W_ResultExt>().Where(e => ids.Contains(e.ResultId)).ToList();
                    });
                    var res = allres.FirstOrDefault(e => e.ResultId == it.Id);
                    if(res != null)
                    {
                        it.PostStatus = res.Status;
                    }
                })
                 .ToPageListAsync(param.offset, param.limit, totalnum);
            return new PageParms<ResultList>
            {
                page = param.offset,
                Items = query,
                totalnum = totalnum,
                limit = param.limit
            };
        }
        /// <summary>
        /// 增加测量记录
        /// </summary>
        /// <param name="myPackage"></param>
        /// <returns></returns>
        public async Task<ResultInfo> InsertResultAsync(MyPackage myPackage)
        {
            //查找设备
            var device = await repository.Change<W_Device>().Context.Queryable<W_Device>().FirstAsync(x => myPackage.IMEI == x.Ecode);
           // _loggerService.AddLogger($"接收到的数据,参数:{myPackage.ToJson()}", 3);
            if (device == null)
            {
                //记录日志
                _loggerService.AddLogger($"设备未找到,参数:{myPackage.ToJson()}", 3);
                return new ResultInfo(ResultState.FAIL, "设备未找到");
            }
            var devicedata = await dbClient.Queryable<W_DeviceData>().FirstAsync(x => x.DeviceId == device.Id);
            var resultid = IDGen.NextID();
            DateTime time = DateTime.Now;
            if (myPackage.IsHeart)
            {
                if (string.IsNullOrEmpty(myPackage.Longitude) || myPackage.Longitude.ToDecimal() == 0) myPackage.Longitude = devicedata != null ? devicedata.Longitude : "0";
                if (string.IsNullOrEmpty(myPackage.Latitude) || myPackage.Latitude.ToDecimal() == 0) myPackage.Latitude = devicedata != null ? devicedata.Latitude : "0";
            }
            else
            {
                if (string.IsNullOrEmpty(myPackage.IMSI)) myPackage.IMSI = devicedata != null ? devicedata.IMSI : "";
                if (string.IsNullOrEmpty(myPackage.IMEI)) myPackage.IMEI = devicedata != null ? devicedata.IMEI : "";
                if (string.IsNullOrEmpty(myPackage.ICCID)) myPackage.ICCID = devicedata != null ? devicedata.ICCID : "";
                if (!string.IsNullOrEmpty(myPackage.Time) && myPackage.Time.Length == 14)
                {
                    time = $"{myPackage.Time.Substring(0, 4)}-{myPackage.Time.Substring(4, 2)}-{myPackage.Time.Substring(6, 2)} {myPackage.Time.Substring(8, 2)}:{myPackage.Time.Substring(10, 2)}:{myPackage.Time.Substring(12, 2)}".ToDate();
                }
            }
            //检查设备是否为今天第一次上报
            bool isfrist = false;
            if (device.LastHeartTime.HasValue && device.LastHeartTime.Value.Date != DateTime.Now.Date)
            {
                isfrist = true;
            }

            if (myPackage.IsChecked && !string.IsNullOrEmpty(myPackage.Area) && myPackage.Area.Length > 0)
            {
                //新的协议中此字段为垃圾桶编号
                var areaBytes = Encoding.Default.GetBytes(myPackage.Area);
                //长度为5个字节,后三位为垃圾桶编号(16进制)
                if (areaBytes.Length == 5)
                {
                    var typeBytes = new byte[3];
                    for (var i = 0; i < 3; i++)
                    {
                        typeBytes[i] = areaBytes[i + 2];
                    }
                    var typeHex = Convert.ToHexString(typeBytes);
                    myPackage.Area = Convert.ToInt32(typeHex, 16).ToString();
                }
                //000F000002.16进制
              //  var areaHex = Convert.ToHexString(areaBytes);

            }
            //记录数据
            await dbClient.Ado.UseStoredProcedure().ExecuteCommandAsync("Proc_InsertResult", new
            {
                deviceid = device.Id,
                businessid = device.Businessid,
                resultid = resultid,
                imei = myPackage.IMEI,
                iccid = myPackage.ICCID,
                imsi = myPackage.IMSI,
                time = time,
                latitude = myPackage.Latitude,
                longitude = myPackage.Longitude,
                sign = myPackage.GSLQ,
                city = myPackage.City,
                area = myPackage.Area,
                wastetype = myPackage.WasteType,
                weigth = myPackage.Weight,
                isheart = myPackage.IsHeart,
                tare = device.Tare,
                isfrist = isfrist
            });
            //上传垃圾数据
            //if (myPackage.IsWeight && myPackage.Weight.ToDecimal() > 0)
            //{
            //    var devicesecret = await repository.Change<W_SZDevice>().Context.Queryable<W_SZDevice>().FirstAsync(x => x.DeviceId == device.Id);
            //    if (devicesecret != null && !string.IsNullOrEmpty(devicesecret.Secret)
            //        && !string.IsNullOrEmpty(devicesecret.SecretHash)
            //        && !string.IsNullOrEmpty(devicesecret.DevId))
            //    {
            //        int timestamp = GetTimestamp(time);
            //        await _suZhouService.PostGarbagesAsync(new GarbagePltC2SDto
            //        {
            //            Weight = myPackage.Weight.ToDouble(),
            //            secret = devicesecret.Secret,
            //            secrethash = devicesecret.SecretHash,
            //            ScanningTime = timestamp,
            //            DStatus = 0,
            //            deviceid = devicesecret.DevId,
            //            Trash = myPackage.Area,
            //            Type = TrashType(myPackage.WasteType)
            //        });
            //    }
            //}
            return new ResultInfo(ResultState.SUCCESS, "success");
        }

        /// <summary>
        /// byte转int
        /// </summary>
        /// <param name="bt"></param>
        /// <returns></returns>
        private static int ByteToInt(byte bt)
        {
            return Convert.ToInt32(((int)bt).ToString("X2"), 16);
        }
        private static int GetTimestamp(DateTime time)
        {
            DateTime dateTimeStart = TimeZoneInfo.ConvertTimeToUtc(new DateTime(1970, 1, 1, 8, 0, 0));
            int timestamp = Convert.ToInt32((time - dateTimeStart).TotalSeconds);
            return timestamp;
        }

        private int TrashType(string type)
        {
            if (type == "厨余垃圾") return 1;
            else if (type == "可回收物") return 2;
            else if (type == "有害垃圾") return 3;
            else if (type == "其他垃圾") return 4;
            else return 0;
        }
    }
}
